最大连续1的个数(滑动窗口)

算法原理:

这道题大眼一看是关于翻转多少个0的问题,但是,如果你按照这种思维去做题,肯定不容易。所以我们要换一种思维去做,这种思维不是一下就能想到的,所以想不到也情有可原。

题目是:给定一个二进制数组 nums 和一个整数 k,如果可以翻转最多 k 个 0 ,则返回 数组中连续 1 的最大个数 。

我们可以转换成:我们求一个子数组,该子数组满足:在一段连续的区间内0的个数不大于k且该数组的长度是所有子数组中最长的

这样其实就类似于一个滑动窗口的问题了。

如果还没有看明白,没关系。详细解释一下:对比以前的滑动窗口,以前的判断条件是求某一段的和最大/求某一段含有不重复的字符最多......,只不过这次的判断条件是0的个数不能超过k,由于这个条件对我们子区间内还要进行操作,所以可能会使你下不去手,困惑。

但是只要抓住本质,按照那个模版来就能写对,这还需要平时多练。

暴力解法就不展示了,就是两个for循环枚举。

代码实现
java 复制代码
class Solution {
        //滑动窗口:
    public int longestOnes(int[] nums, int k) {
        int ret=0;
        for(int left =0,right =0,zero =0;right<nums.length;right++){
            if(nums[right] == 0){
                zero++;//进窗口
            }
             while(zero>k){//判断
                    if(nums[left++] == 0){
                        zero--;//出窗口
                    }
                }
            ret = Math.max(ret,right - left + 1);//更新结果
        }
        return ret;
    }
}
相关推荐
zhangfeng11334 分钟前
qjlDim 含义 TurboQuant QJL Quantized Johnson-Lindenstrauss,量化JL随机投影
人工智能·算法·ai编程·npu
HwJack205 分钟前
【HarmonyOS开发小实践】HarmonyOS GC 引用计数 vs 对象追踪,三种回收算法
jvm·算法·harmonyos
blxr_7 分钟前
力扣hot100前k个高频元素https://leetcode.cn/problems/top-k-frequent-elements/
算法·leetcode·职场和发展
longlongzihan10 小时前
LeetCode 17电话号码的字母组合:回溯算法(DFS)详解
c++·算法·leetcode·深度优先
封印师请假去地球钓鱼10 小时前
边解边变的问题:从“决策依赖“一词出发
人工智能·算法
今晚打老虎11 小时前
c++之提高A(前缀和)(第三课)
数据结构·c++·算法
不会就选b12 小时前
算法日常・每日刷题--<贪心>26
数据结构·算法
hetao173383713 小时前
2026-09-29 hetao1733837 的刷题记录
c++·算法
欣欣之王来了14 小时前
AI合规专项:AI算法透明度的合规要求
人工智能·算法
wzdark14 小时前
分块思想在算法优化中的实践与应用4
算法